/*
    This file is part of peda.
    Copyright (C) 2000-2010  Petr Porazil <porazil@volny.cz>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef Part_included
#define Part_included

#include "Atr.h"
#include "DbPcb.h"

#include <QString>
//#include <qtstream.h>
#include <QPainter>
#include <QFont>


class Part
{

struct PartL {
 int St;
 QString BName;
 Atrib Atr;
 QPoint p;
 int rot;
 int mir;
 int typ;
 PartL * Next;
};


public:

 Part();
 virtual ~Part();

 void AddAtr(Atrib & A);
 void List();
 void Sort();
 void SetType(int t);

 QString * GetHead();
 QString * GetTail();

 void AddCenter(DbPcb * P,int x, int y);

 void SetFName(QString & n);
 bool ConvHead(const char * H,QString * L,QString * R,int pn);


 int CmpAtr(Atrib & A1,Atrib & A2,int fl=0);

 int WriteCsv(QTextStream &S,int flag);
 int DrawPage(QPainter &P,QFont &Font,int NP,int Form=0);

protected:


private:
  QString FName;
  QString BName;
  QString Head;
  QString Tail;
  PartL  * PL;

  int Typ;

  int tab;
  int tab1;
  int tab2;

};


#endif
